﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using C1.WPF.C1Chart;
using C1.WPF.Theming;

namespace WPF_Chart_Animations
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            var rnd = new Random();
            chart.MouseLeftButtonDown += (s, e) =>
            {
                chart.Data.Children.Clear();
               //create chart data
                var vals = new double[rnd.Next(5, 10)];
                for (int i = 0; i < vals.Length; i++)
                    vals[i] = rnd.Next(0, 100);
                chart.Data.Children.Add(new DataSeries() { ValuesSource = vals });
                chart.View.AxisX.Min = -0.5;
                chart.View.AxisX.Max = vals.Length - 0.5;

              //handle the PlotElementLoaded event
                chart.Data.Children[0].PlotElementLoaded += chart_PlotElementLoaded;
            };

             Application.Current.Resources.MergedDictionaries.
    Add(C1Theme.GetCurrentThemeResources(new C1.WPF.Theming.Office2010.C1ThemeOffice2010Blue()));

        }

        private void chart_Loaded(object sender, RoutedEventArgs e)
        {
            //Create a new PlotElementAnimation object
            PlotElementAnimation animation = new PlotElementAnimation();

            //Set the style to assign to the PlotElementAnimation 
             Style style = new Style(typeof(PlotElement));
            style.Setters.Clear();
            style.Setters.Add(new Setter(PlotElement.OpacityProperty, 0.0));
            animation.SymbolStyle = style;

            //Set the storyboard to be assigned to the PlotElementAnimation
            Storyboard storyboard = new Storyboard();
            DoubleAnimation doubleAnimation = new DoubleAnimation(1.0, new Duration(new TimeSpan(0, 0, 1)));
            Storyboard.SetTargetProperty(doubleAnimation, new PropertyPath(PlotElement.OpacityProperty));
            PlotElementAnimation.SetIndexDelay(doubleAnimation, 0.5d);
            storyboard.Children.Clear();
            storyboard.Children.Add(doubleAnimation);
            animation.Storyboard = storyboard;

            //Set the object to PlotElementAnimation Data.LoadAnimation property of the Chart control
            chart.Data.LoadAnimation = animation;
        }

        void chart_PlotElementLoaded(object sender, EventArgs e)
        {
            //Specify the plot elements of the story as the target board
            PlotElement pe = sender as PlotElement;
            var doubleAnimation = chart.Data.LoadAnimation.Storyboard.Children[0] as DoubleAnimation;
            if (doubleAnimation != null)
                Storyboard.SetTarget(doubleAnimation, pe);
        }
    }
}
